import java.util.*;
/** Programmname: RoboCup-Kamikaze-Client <br>
* Klasse: BodyEvent
* <hr>
* bereitet die "hear"-Nachrichten vom Server fr die Weiterverarbeitung durch das Welmodell vor.
* <hr>
* @see WorldModel
* @author Kamil
* @version 1.0 
*/
public class AuralEvent 
{
	//list of messages
	private Vector objectPerceptionList = new Vector();

	//Operationen
	/**
	 * gibt die Liste der "gehrten" Objekte zurck
	 * @return eine <code>Enumeration</code>, deren Elemente Objekte des Typs <code>ObjectPerceptionAural</code>
	 * sind
	 * @see <code>ObjectPerceptionAural</code>
	 */
	public Enumeration elements()
	{
		return objectPerceptionList.elements();
	}
	//adds an element to the internal list
	void add(ObjectPerceptionAural objectPerceptionAu)
	{
		objectPerceptionList.addElement(objectPerceptionAu);
	}
	/**
	* @param message des Server-<code>Strings</code> der "hear"-Nachricht
	*/
	public AuralEvent(String Message)
	{
		// use parantheses as string delimiters
		StringTokenizer tokenizer = new StringTokenizer(Message, "()");
		// tokenizer.nextToken() returns something like for example: "hear 12 referee corner_kick_l"
		String code=tokenizer.nextToken();
		// use space as string delimiters
		StringTokenizer tokenizer2 = new StringTokenizer(code, " ");
		// The first Token2 extracted would be:
		// "hear" , we skip it.
		tokenizer2.nextToken();
		//get the time
		String Time = tokenizer2.nextToken();
		int time  = Integer.parseInt(Time);
		// get the name of the Sender
		String sender=tokenizer2.nextToken();
		// get the message
		String message=tokenizer2.nextToken();
		// create a new object info
		ObjectPerceptionAural objectPerceptionAu = new ObjectPerceptionAural(time, sender, message);
		this.add(objectPerceptionAu);
	}
}