import java.util.*;
/** Programmname: RoboCup-Kamikaze-Client <br>
* Klasse: BodyEvent
* <hr>
* bereitet die "sense_body"-Nachrichten vom Server fr die Weiterverarbeitung durch das Welmodell vor.
* <hr>
* @see WorldModel
* @author Michael Wagner
* @version 1.0 / 5.7.02
*/

public class BodyEvent 
{
	//Objektattribute
	private double stamina = 0;
	private double speed = 0;
	private int headAngle=0;
	private int time=-1;
	private String viewQuality="";
	private String viewWidth="";
    
	//Konstruktor
	/**
	* @param message der Server-<code>String</code> der "sense_body"-Nachricht
	*/
	public BodyEvent(String message)
	{	//tokenize message
		StringTokenizer messageTok = new StringTokenizer(message,"() ");
		while(messageTok.hasMoreTokens())
		{
			String currentToken = messageTok.nextToken();
			//set stamina
			if(currentToken.equals("stamina"))
				stamina=Double.parseDouble(messageTok.nextToken());
			//set speed
			if(currentToken.equals("speed"))
				speed=Double.parseDouble(messageTok.nextToken());
			//set headAngle
			if(currentToken.equals("head_angle"))
				headAngle=Integer.parseInt(messageTok.nextToken());
			//set time
			if(currentToken.equals("sense_body"))
				time=Integer.parseInt(messageTok.nextToken());
			//set viewQuality & viewWidth
			if(currentToken.equals("view_mode"))
			{
				viewQuality=messageTok.nextToken();
				viewWidth=messageTok.nextToken();
			}
		}
	}

	//Operationen
	/**
	* Ausdauer	 
	* @return einen <code>double</code>-Wert
	*/
	public double stamina()
	{
		return stamina;
	}
    
	/**
	* Geschwindigkeit des Spielers
	* @return einen <code>double</code>-Wert
	*/
	public double speed()
	{
		return speed;
	}

	/**
	* Blickwinkel relativ zur Krperrichtung
	* @return einen <code>int</code>-Wert
	*/
	public int headAngle()
	{
		return headAngle;
	}
	
	/**
	* aktuelle Spielzeit
	* @return einen <code>int</code>-Wert
	*/
	public int time()
	{
		return time;
	}
    
	/**
	* die Blickqualitt
	* @return einen <code>String</code>; mgliche Werte sind "high" oder "low"
	*/
	public String viewQuality()
	{
		return viewQuality;
	}

	/**
	* die Blickwinkelgre
	* @return einen <code>String</code>; mgliche Werte sind "wide","normal" oder "narrow"
	*/
	public String viewWidth()
	{
		return viewWidth;
	}

}