/** Programmname: RoboCup-Kamikaze-Client
* Klasse: ObjectPerception
* <hr>
* reprsentiert ein vom Spieler gesehenes Objekt
* <hr>
* Standardwerte sind:
* <ul>
* <li> <code>int</code>- und <code>double</code>-Werte: 5000
* <li> <code>String</code>-Werte: ""
* <li> <code>boolean</code>-Werte: false
* </ul>
* @author Kamil/Michael Wagner
* @version 1.0 / 4.7.02
*/

public class ObjectPerception
{
	//Attribute
	private int time = 5000;
	String objName = "";
	private double distance = 5000;
	private int direction = 5000;
	private double distChange = 5000;
	private double dirChange = 5000;
	private int bodyFacingDir = 5000;
	private int headFacingDir = 5000;
	private String teamName = "";
	private int uniformNumber = 5000;
	private boolean isGoalie = false;

	//Konstruktoren
	/**
	* 
	*/
	public ObjectPerception()
	{
	}

    /**
    * 
    * @param time	die Zeit, zur der das Objekt gesehen wurde (Typ: <code>int</code>)
    * @param distance	die Distanz des Spielers zum Objekt (Typ: <code>double</code>)	
    * @param direction	die relative Richtung des Objekts (Typ: <code>int</code>)
    * @param distChange die Distanzvernderung seit dem letzten Cycle (Typ: <code>double</code>)
    * @param dirChange	die Richtungsvernderung seit dem letzten Cycle (Typ: <code>double</code>)
    * @param bodyFacingDir die Richtung des Krpers (Typ: <code>int</code>)
    * @param headFacingDir die Richtung des Kopfs (Typ: <code>int</code>)
    * @param teamName der Teamname (Typ: <code>String</code>)
    * @param uniformNumber die Trikotnummber (Typ: <code>int</code>)
    */
	public ObjectPerception(int time,double distance, int direction, double distChange, double dirChange, int bodyFacingDir, int headFacingDir, String teamName, int uniformNumber)
	{
		this.time=time;
		this.distance=distance;
		this.direction=direction;
		this.distChange=distChange;
		this.dirChange=dirChange;
		this.bodyFacingDir=bodyFacingDir;
		this.headFacingDir=headFacingDir;
		this.teamName=teamName;
		this.uniformNumber=uniformNumber;
	}

	/**
    * 
    * @param time	die Zeit, zur der das Objekt gesehen wurde (Typ: <code>int</code>)
    * @param objName der Objektname (z.B. "p","l","b",etc) (Typ: <code>String</code>)
    * @param distance	die Distanz des Spielers zum Objekt (Typ: <code>double</code>)	
    * @param direction	die relative Richtung des Objekts (Typ: <code>int</code>)
    * @param distChange die Distanzvernderung seit dem letzten Cycle (Typ: <code>double</code>)
    * @param dirChange	die Richtungsvernderung seit dem letzten Cycle (Typ: <code>double</code>)
    * @param bodyFacingDir die Richtung des Krpers (Typ: <code>int</code>)
    * @param headFacingDir die Richtung des Kopfs (Typ: <code>int</code>)
    * @param teamName der Teamname (Typ: <code>String</code>)
    * @param uniformNumber die Trikotnummber (Typ: <code>int</code>)
    */
	public ObjectPerception(int time,String objName, double distance, int direction, double distChange, double dirChange, int bodyFacingDir, int headFacingDir, String teamName, int uniformNumber)
	{
		this.time=time;
		this.objName=objName;
		this.distance=distance;
		this.direction=direction;
		this.distChange=distChange;
		this.dirChange=dirChange;
		this.bodyFacingDir=bodyFacingDir;
		this.headFacingDir=headFacingDir;
		this.teamName=teamName;
		this.uniformNumber=uniformNumber;
	}
	/**
    * 
    * @param time	die Zeit, zur der das Objekt gesehen wurde (Typ: <code>int</code>)
    * @param distance	die Distanz des Spielers zum Objekt (Typ: <code>double</code>)	
    * @param direction	die relative Richtung des Objekts (Typ: <code>int</code>)
    * @param distChange die Distanzvernderung seit dem letzten Cycle (Typ: <code>double</code>)
    * @param dirChange	die Richtungsvernderung seit dem letzten Cycle (Typ: <code>double</code>)
    * @param bodyFacingDir die Richtung des Krpers (Typ: <code>int</code>)
    * @param headFacingDir die Richtung des Kopfs (Typ: <code>int</code>)
    * @param teamName der Teamname (Typ: <code>String</code>)
    * @param uniformNumber die Trikotnummber (Typ: <code>int</code>)
    * @param isGoalie das Objekt Torwart oder nicht? (Typ: <code>double</code>)
    */
	public ObjectPerception(int time,double distance, int direction, double distChange, double dirChange, int bodyFacingDir, int headFacingDir, String teamName, int uniformNumber, boolean isGoalie)
	{
		this.time=time;
		this.distance=distance;
		this.direction=direction;
		this.distChange=distChange;
		this.dirChange=dirChange;
		this.bodyFacingDir=bodyFacingDir;
		this.headFacingDir=headFacingDir;
		this.teamName=teamName;
		this.uniformNumber=uniformNumber;
		this.isGoalie=isGoalie;
	}
	//Operationen
	/**
	* Zeit, zu der das Objekt gesehen wurde 
	* @return einen <code>int</code>-Wert
	*/
	public int time()
	{
		return time;
	}

	/**
	* Name des Objekts (z.B "b","p","g")
	* @return einen <code>String</code>
	*/
	public String objName()
	{
		return objName;
	}

	/**
	* Entfernung zum Objekt 
	* @return einen <code>double</code>-Wert
	*/
	public double distance()
	{
		return distance;
	}

	/**
	* relative Richtung zum Objekt
	* @return einen <code>int</code>-Wert
	*/
	public int direction()
	{
		return direction;
	}

	/**
	* Entfernungsnderung des Objekts seit dem letzten Cycle
	* @return einen <code>double</code>-Wert
	*/
	public double distChange()
	{
		return distChange;
	}

	/**
	* Richtungsnderung des Objekts seit dem letzten Cycle 
	* @return einen <code>double</code>-Wert
	*/
	public double dirChange()
	{
		return dirChange;
	}

	/**
	* Blickrichtung des Objekts 
	* @return einen <code>int</code>-Wert
	*/
	public int headFacingDir()
	{
		return headFacingDir;
	}

	/**
	* Krperrichtung des Objekts 
	* @return einen <code>int</code>-Wert
	*/
	public int bodyFacingDir()
	{
		return bodyFacingDir;
	}

	/**
	*  das zugehrige Team 
	* @return einen <code>int</code>-Wert
	*/
	public String teamName()
	{
		return teamName;
	}

	/**
	* Trikotnummer
	* @return einen <code>int</code>-Wert
	*/
	public int uniformNumber()
	{
		return uniformNumber;
	}
	/**
	 * ist Objekt Torwart?
	 * @return einen <code>boolean</code>-Wert
	 */
	public boolean isGoalie() {
		return isGoalie;
	}
}