import java.awt.*;
import java.util.*;


/** Programmname: RoboCup-Kamikaze-Client    <br>
*   Klasse: VisualWorldModel (abgeleitet von der Frame Klasse)  <br>
*   Visualisiert das Weltmodell jedes einzelnen Spieler
*   @author Kamil
*   @version 1.0 / 4.7.02
*/
public class VisualWorldModel extends Frame
{
  //Attribute
    private VisualWorldModel vwm;
    private ServerListener SL;
    Field field;
    SmallField sfield;
    //ball
    double ballXX, ballYY;
    int ballX;
    int ballY;
    boolean ballInSight;
    //players
    Enumeration players;
    double playerPosXX, playerPosYY;
    int playerPosX;
    int playerPosY;
    String teamname;
    int uniformNr;
    int blickRichtung;
    double stamina;
    //own position
    double ep[];       // ep[0] = x, ep[1] = y
    int eigenePosX ;
    int eigenePosY ;
    int eigenePosXX ;
    int eigenePosYY ;
    String PlayMode;
    int[] score;
    String opTeamName = "opponent";
    int iii = 0;
    String TeamName;
    String side;
    int time;

    //Konstruktor
    /**
    *  erzeugt ein neues VisualWorldModel-Fenster fr einen Spieler
    *  @param     sl  Server Listener
    *  @param     spieler     String
    */
    public VisualWorldModel(ServerListener sl, String spieler)
    {
        SL = sl;
        setSize(460,410);         // set frame size
        setLocation(500,405);     //set frame location
        setLayout(null);          //set a null layout
        setTitle("   VISUAL-WORLD-MODEL ("+spieler+")  ");  // set frame title
        setResizable(false);
        Color c = new Color(94,185,89);
        setBackground(c);          // set frame background colour
        field = new Field();       //creat a Field canvas
       // field.setDoubleBuffered(true);
        field.setBounds(20,43,420,272);  // set canvas bounds
        field.setBackground(c);    // set canvas background colour
        add(field);              // add Field canvas
        field.receiveDaten();
        sfield = new SmallField();   //creat a SmallField canvas
        sfield.setBounds(20, 320, 420, 80);   // set canvas bounds
        sfield.setBackground(new Color(73,44,120));  // set canvas background colour
        add(sfield);              // add SmallField canvas
        sfield.receiveDaten2();
        setVisible(true);         // show frame
        }

/** Klasse: Field (abgeleitet von der Canvas Klasse)  <br>
*   Malt das Spielfeld und alle bewegliche Objekte
*   @author Kamil
*   @version 1.0 / 4.7.02
*/
public class Field extends Canvas
{
        //Attribute
        int w1, w2;
        Stroke line2 = new BasicStroke(2,BasicStroke.CAP_BUTT,BasicStroke.JOIN_MITER);
        Stroke line0 = new BasicStroke(0);
        Stroke line1 = new BasicStroke(1);

        BasicStroke lineSpace = new BasicStroke(0, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER,
                                            10, new float[] {10, 20, }, 40);
        BasicStroke lineSpacePlayer = new BasicStroke(0, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER,
                                                  2, new float[] {2, 2, }, 0);
        BasicStroke lineSpaceBall = new BasicStroke(0, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER,
                                                2, new float[] {1, 2, }, 0);
    
        //Operationen
        /** Methode dient zur Aktualisierung der Daten
        *   @param     keine Parameter
        *   @return    kein Return-Wert
        */
        public void receiveDaten()
        {
             //       new Thread( new Runnable()  {        //starte ein Thread, das ganze Zeit die Position aktualisiert
             //       public void run(){
             //       while (true){
             //          Event event = SL.event();
             //          if (event.isVisualEvent())
        //player's info
        players = SL.wm.getSeenPlayerList();
        //uniform number
        uniformNr = SL.wm.getUnum();
        //team name
        teamname = SL.wm.getTeamName();
        //abs. direction
        blickRichtung = SL.wm.getViewDirection();
   //     System.out.println("absolute Blickrichtung = "+blickRichtung);
        //time
        time = SL.wm.getTime();
        //side
        side = SL.wm.getSide();
        //player position
        ep = SL.wm.getPlayerPos();

        if(SL.wm.ballInSight())
        {
            ballInSight = true;
            ballXX = SL.wm.getBallX();
            ballYY = SL.wm.getBallY();
       //   System.out.println("BallX = "+ballXX+"    BallY = "+ballYY);
                if (side.equals("l"))
                      {
                         if( time <= 3000)
                            {
                              ballX = (int)(4*(52.5 + ballXX));
                              ballY = (int)(4*(34 + ballYY));
                            }
                         if( time >= 3001)
                            {
                              ballX = (int)(4*(52.5 - ballXX));
                              ballY = (int)(4*(34 - ballYY));
                            }
                       }
                else
                      {
                         if( time <= 3000)
                            {
                              ballX = (int)(4*(52.5 - ballXX));
                              ballY = (int)(4*(34 - ballYY));
                            }
                         if( time >= 3001)
                            {
                              ballX = (int)(4*(52.5 + ballXX));
                              ballY = (int)(4*(34 + ballYY));
                            }
                       }
                }
           else
                   {
                        ballInSight = false;
                   }

        if(side.equals("l") )
                {
                   if( time <= 3000)
                       {
                            eigenePosX = (int)(4*(52.5 + ep[0]));
                            eigenePosY = (int)(4*(34 + ep[1]));
                       }
                   if( time >= 3001)
                       {
                            eigenePosX = (int)(4*(52.5 - ep[0]));
                            eigenePosY = (int)(4*(34 - ep[1]));
                       }
                 }
        else
                 {
                    if( time <= 3000)
                         {
                            eigenePosX = (int)(4*(52.5 - ep[0]));
                            eigenePosY = (int)(4*(34 - ep[1]));
                         }
                    if( time >= 3001)
                         {
                            eigenePosX = (int)(4*(52.5 + ep[0]));
                            eigenePosY = (int)(4*(34 + ep[1]));
                         }
                 }
     //         System.out.println("eigenePosX = "+ep[0]+"   eigenePosY = "+ep[1]);
                //       }}}
                //                   ).start();
      }


        /** Methode zeichnet statische und bewegliche Objekte
        *   @param     g    Graphics
        *   @return    kein Return-Wert
        *   @see java.awt.Graphics
        *   @see java.awt.Graphics2D
        */
        public void paint(Graphics g)
    {
        //draw Field
        Graphics2D gg = (Graphics2D)g;
        g.setColor(Color.white);
        gg.setStroke(line2);
        g.drawLine(210,0,210,272);  // line (middle)
        g.drawLine(0,1,420,1);      // line (top)
        g.drawLine(419,0,419,272);  // line (rights)
        g.drawLine(420,271,0,271);  // line (bottom)
        g.drawLine(1,0,1,272);      // line (links)
        g.drawRect(1,56,66,160);      // penalty box (links)
        g.drawRect(353,56,66,160);      // penalty box (rights)
        g.drawRect(1,100,22,72);      // goal box (links)
        g.drawRect(397,100,22,72);      // goal box (rights)
        g.drawRect(44,136,1,1);      // punkt (links)
        g.drawRect(375,136,1,1);      // punkt (rights)
        g.drawOval(174,100,72,72);    // center of the field
        g.drawArc(8,100,72,72,-50,100);    // arc (links)
        g.drawArc(340,100,72,72,130,100);    // arc (rights)
        g.setColor(Color.blue);
        g.drawLine(2,106,2,166);      // goal (links)
        g.drawLine(418,106,418,166);      // goal (rights)
        // draw ball
        if(ballInSight)
        {
                Color darkRed = new Color(201, 16, 0);
            g.setColor(darkRed);
            g.fillOval(ballX-5,ballY-5,10,10);
            gg.setStroke(lineSpaceBall);
            g.setColor(Color.black);
            g.drawOval(ballX-5,ballY-5,9,9);
            gg.setStroke(line2);
        }
        //draw Players
        for(Enumeration e=players; e.hasMoreElements() ;)
        {
                PlayerPerception playPer = (PlayerPerception)e.nextElement();
            //Fall1: Tn yes
            if ( !playPer.teamName().equals("%===") )
            {
                if ( playPer.teamName().equals(teamname) )
                {
                        playerPosXX = playPer.absX();
                    playerPosYY = playPer.absY();
                    if( side.equals("l") )
                    {
                        if ( time <= 3000)
                        {
                                playerPosX = (int)(4*(52.5 + playerPosXX));
                                playerPosY = (int)(4*(34 + playerPosYY));
                                }
                        if ( time >= 3001)
                        {
                                playerPosX = (int)(4*(52.5 - playerPosXX));
                                playerPosY = (int)(4*(34 - playerPosYY));
                        }
                    }
                    else
                    {
                        if ( time <= 3000)
                        {
                                playerPosX = (int)(4*(52.5 - playerPosXX));
                                playerPosY = (int)(4*(34 - playerPosYY));
                        }
                        if ( time >= 3001)
                        {
                                playerPosX = (int)(4*(52.5 + playerPosXX));
                                playerPosY = (int)(4*(34 + playerPosYY));
                        }
                    }
                    //body
                    Color violet = new Color(137, 40, 144);
                    g.setColor(violet);
                    g.fillOval(playerPosX-7,playerPosY-7,14,14);
                    g.setColor(Color.black);
                    //eyes
                    gg.setStroke(line0);
                    //Color yellow = new Color(137, 40, 144);
                    g.drawOval(playerPosX-6,playerPosY-5,4,4);
                    g.drawOval(playerPosX,playerPosY-5,4,4);
                    g.fillOval(playerPosX-4,playerPosY-4,3,3);
                    g.fillOval(playerPosX,playerPosY-4,3,3);
                    //uniform-number
                    if ( playPer.uniformNumber() != 5000 )
                    {
                        g.setColor(Color.white);
                        g.setFont(new Font("SansSerif",Font.BOLD,9));
                        if (playPer.uniformNumber() == 10 || playPer.uniformNumber() == 11)
                                g.drawString(""+playPer.uniformNumber(), playerPosX-5, playerPosY+6);
                        else
                                g.drawString(""+playPer.uniformNumber(), playerPosX-2, playerPosY+6);
                        }
                    //legs
                    g.setColor(Color.white);
                    gg.setStroke(line1);
                    g.drawLine(playerPosX-4, playerPosY+6, playerPosX-4, playerPosY+9);
                    g.drawLine(playerPosX+3, playerPosY+6, playerPosX+4, playerPosY+9);
                    //arms
                    g.drawLine(playerPosX-8, playerPosY, playerPosX-9, playerPosY+1);
                    g.drawLine(playerPosX+7, playerPosY, playerPosX+8, playerPosY+1);
                    //shoes
                    g.setColor(Color.black);
                    g.drawLine(playerPosX-4, playerPosY+9, playerPosX-5, playerPosY+8);
                    g.drawLine(playerPosX+4, playerPosY+9, playerPosX+5, playerPosY+8);
                        }

                   if ( !playPer.teamName().equals(teamname) )  {
                      if (iii == 0) {opTeamName = playPer.teamName(); iii++;}

                      playerPosXX = playPer.absX();
                      playerPosYY = playPer.absY();

                    if( side.equals("l") )  {
                      if ( time <= 3000)  {
                      playerPosX = (int)(4*(52.5 + playerPosXX));
                      playerPosY = (int)(4*(34 + playerPosYY));
                      }
                      if ( time >= 3001)  {
                      playerPosX = (int)(4*(52.5 - playerPosXX));
                      playerPosY = (int)(4*(34 - playerPosYY));
                      }
                     }
                    else {
                      if ( time <= 3000)  {
                      playerPosX = (int)(4*(52.5 - playerPosXX));
                      playerPosY = (int)(4*(34 - playerPosYY));
                      }
                      if ( time >= 3001)  {
                      playerPosX = (int)(4*(52.5 + playerPosXX));
                      playerPosY = (int)(4*(34 + playerPosYY));
                      }
                    }
                    //body
                      Color blue = new Color(16, 40, 147);
                      gg.setStroke(line2);
                      g.setColor(blue);
                      g.fillOval(playerPosX-7,playerPosY-7,14,14);
                      g.setColor(Color.black);
                    //eyes
                      gg.setStroke(line0);
                      g.fillOval(playerPosX-4,playerPosY-4,4,4);
                      g.fillOval(playerPosX,playerPosY-4,4,4);
                      g.drawOval(playerPosX-7,playerPosY-5,6,6);
                      g.drawOval(playerPosX,playerPosY-5,6,6);
                    //hairs
                      Color brown = new Color(131, 72, 55);
                      g.setColor(brown);
                      g.drawLine(playerPosX-4,playerPosY-7,playerPosX-5,playerPosY-8);
                      g.drawLine(playerPosX+4,playerPosY-7,playerPosX+5,playerPosY-8);
                      g.drawLine(playerPosX-1,playerPosY-7,playerPosX-2,playerPosY-9);
                      g.drawLine(playerPosX+1,playerPosY-7,playerPosX+2,playerPosY-9);
                    //uniform-number
                      if ( playPer.uniformNumber() != 5000 )  {
                        g.setColor(Color.white);
                        g.setFont(new Font("SansSerif",Font.BOLD,9));
                        if (playPer.uniformNumber() == 10 || playPer.uniformNumber() == 11)
                        g.drawString(""+playPer.uniformNumber(), playerPosX-5, playerPosY+6);
                        else
                        g.drawString(""+playPer.uniformNumber(), playerPosX-2, playerPosY+6);
                      }
                    //legs
                      g.setColor(Color.white);
                      gg.setStroke(line1);
                      g.drawLine(playerPosX-4, playerPosY+6, playerPosX-4, playerPosY+9);
                      g.drawLine(playerPosX+3, playerPosY+6, playerPosX+4, playerPosY+9);
                    //arms
                      g.drawLine(playerPosX-8, playerPosY, playerPosX-9, playerPosY+1);
                      g.drawLine(playerPosX+7, playerPosY, playerPosX+8, playerPosY+1);
                    //shoes
                      g.setColor(Color.black);
                      g.drawLine(playerPosX-4, playerPosY+9, playerPosX-5, playerPosY+8);
                      g.drawLine(playerPosX+4, playerPosY+9, playerPosX+5, playerPosY+8);
                                                }


                   }
                   //Fall2: Tm no, Un no
                   else  {
                      playerPosXX = playPer.absX();
                      playerPosYY = playPer.absY();

                    if( side.equals("l") )  {
                      if ( time <= 3000)  {
                      playerPosX = (int)(4*(52.5 + playerPosXX));
                      playerPosY = (int)(4*(34 + playerPosYY));
                      }
                      if ( time >= 3001)  {
                      playerPosX = (int)(4*(52.5 - playerPosXX));
                      playerPosY = (int)(4*(34 - playerPosYY));
                      }
                     }
                    else {
                      if ( time <= 3000)  {
                      playerPosX = (int)(4*(52.5 - playerPosXX));
                      playerPosY = (int)(4*(34 - playerPosYY));
                      }
                      if ( time >= 3001)  {
                      playerPosX = (int)(4*(52.5 + playerPosXX));
                      playerPosY = (int)(4*(34 + playerPosYY));
                      }
                    }
                    //body
                      gg.setStroke(lineSpacePlayer);
                      g.setColor(Color.black);
                      g.drawOval(playerPosX-7,playerPosY-7,14,14);
                    //legs
                      g.setColor(Color.white);
                      gg.setStroke(line1);
                      g.drawLine(playerPosX-4, playerPosY+6, playerPosX-4, playerPosY+9);
                      g.drawLine(playerPosX+3, playerPosY+6, playerPosX+4, playerPosY+9);
                    //arms
                      g.drawLine(playerPosX-8, playerPosY, playerPosX-9, playerPosY+1);
                      g.drawLine(playerPosX+7, playerPosY, playerPosX+8, playerPosY+1);
                    //shoes
                      g.setColor(Color.black);
                      g.drawLine(playerPosX-4, playerPosY+9, playerPosX-5, playerPosY+8);
                      g.drawLine(playerPosX+4, playerPosY+9, playerPosX+5, playerPosY+8);
                   }

                 }
              // draw me
                 if(eigenePosX != -1 || eigenePosY != -1)
                 {
                  gg.setStroke(line2);
                  Color violet = new Color(137, 40, 144);
                  g.setColor(violet);
                  g.fillOval(eigenePosX-7,eigenePosY-7,14,14);
                  g.setColor(Color.black);

              //Blickrichtung
                  gg.setStroke(lineSpace);
                  w1 = blickRichtung-45;
                  w2 = blickRichtung+45;
                if ( w1 != 90 && w2 != 90 && w1 != -90 && w2 != -90 )  {
                  if( w1 > 180) w1 = w1 - 360;
                  if( w2 > 180) w2 = w2 - 360;
                  if( w1 < -180) w1 = w1 + 360;
                  if( w2 < -180) w2 = w2 + 360;
                //   System.out.println("w1 =   "+w1);
                //   System.out.println("w2 =   "+w2);
                   double c = Math.PI;
                   double w1Pi = c*(w1/180.0);
                   double wertTgw1 = Math.tan(w1Pi);
                   double w2Pi = c*(w2/180.0);
                   double wertTgw2 = Math.tan(w2Pi);
             if( side.equals("l") )  {
               if ( time <= 3000)  {
                  if (w1 > -90 && w1 <= 0)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX+400, eigenePosY + (int)(wertTgw1 * (400)) );
                  if (w1 >= 0 && w1 < 90)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX+400, eigenePosY + (int)(wertTgw1 * (400)) );
                  if (w1 < -90 && w1 > -180)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX-400, eigenePosY + (int)(wertTgw1 * (-400)) );
                  if (w1 > 90 && w1 < 180)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX-400, eigenePosY + (int)(wertTgw1 * (-400)) );

                  if (w2 > -90 && w2 <= 0)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX+400, eigenePosY + (int)(wertTgw2 * (400)) );
                  if (w2 >= 0 && w2 < 90)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX+400, eigenePosY + (int)(wertTgw2 * (400)) );
                  if (w2 < -90 && w2 > -180)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX-400, eigenePosY + (int)(wertTgw2 * (-400)) );
                  if (w2 > 90 && w2 < 180)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX-400, eigenePosY + (int)(wertTgw2 * (-400)) );
               }
               if ( time >= 3001)  {
                  if (w1 > -90 && w1 <= 0)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX-400, eigenePosY - (int)(wertTgw1 * (400)) );
                  if (w1 >= 0 && w1 < 90)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX-400, eigenePosY - (int)(wertTgw1 * (400)) );
                  if (w1 < -90 && w1 > -180)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX+400, eigenePosY - (int)(wertTgw1 * (-400)) );
                  if (w1 > 90 && w1 < 180)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX+400, eigenePosY - (int)(wertTgw1 * (-400)) );

                  if (w2 > -90 && w2 <= 0)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX-400, eigenePosY - (int)(wertTgw2 * (400)) );
                  if (w2 >= 0 && w2 < 90)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX-400, eigenePosY - (int)(wertTgw2 * (400)) );
                  if (w2 < -90 && w2 > -180)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX+400, eigenePosY - (int)(wertTgw2 * (-400)) );
                  if (w2 > 90 && w2 < 180)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX+400, eigenePosY - (int)(wertTgw2 * (-400)) );
               }
             }
             else  {
                if ( time <= 3000)  {
                  if (w1 > -90 && w1 <= 0)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX-400, eigenePosY - (int)(wertTgw1 * (400)) );
                  if (w1 >= 0 && w1 < 90)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX-400, eigenePosY - (int)(wertTgw1 * (400)) );
                  if (w1 < -90 && w1 > -180)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX+400, eigenePosY - (int)(wertTgw1 * (-400)) );
                  if (w1 > 90 && w1 < 180)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX+400, eigenePosY - (int)(wertTgw1 * (-400)) );

                  if (w2 > -90 && w2 <= 0)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX-400, eigenePosY - (int)(wertTgw2 * (400)) );
                  if (w2 >= 0 && w2 < 90)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX-400, eigenePosY - (int)(wertTgw2 * (400)) );
                  if (w2 < -90 && w2 > -180)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX+400, eigenePosY - (int)(wertTgw2 * (-400)) );
                  if (w2 > 90 && w2 < 180)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX+400, eigenePosY - (int)(wertTgw2 * (-400)) );
                 }
               if ( time >= 3001)  {
                  if (w1 > -90 && w1 <= 0)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX+400, eigenePosY + (int)(wertTgw1 * (400)) );
                  if (w1 >= 0 && w1 < 90)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX+400, eigenePosY + (int)(wertTgw1 * (400)) );
                  if (w1 < -90 && w1 > -180)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX-400, eigenePosY + (int)(wertTgw1 * (-400)) );
                  if (w1 > 90 && w1 < 180)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX-400, eigenePosY + (int)(wertTgw1 * (-400)) );

                  if (w2 > -90 && w2 <= 0)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX+400, eigenePosY + (int)(wertTgw2 * (400)) );
                  if (w2 >= 0 && w2 < 90)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX+400, eigenePosY + (int)(wertTgw2 * (400)) );
                  if (w2 < -90 && w2 > -180)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX-400, eigenePosY + (int)(wertTgw2 * (-400)) );
                  if (w2 > 90 && w2 < 180)
                     g.drawLine(eigenePosX, eigenePosY, eigenePosX-400, eigenePosY + (int)(wertTgw2 * (-400)) );
               }
             }

                }
                //eyes
                  gg.setStroke(line0);
                  g.drawOval(eigenePosX-6,eigenePosY-5,4,4);
                  g.drawOval(eigenePosX,eigenePosY-5,4,4);
                  g.fillOval(eigenePosX-4,eigenePosY-4,3,3);
                  g.fillOval(eigenePosX,eigenePosY-4,3,3);
                //uniform-number
                  g.setColor(Color.white);
                  g.setFont(new Font("SansSerif",Font.BOLD,9));
                  if (uniformNr == 10 || uniformNr == 11)
                  g.drawString(""+uniformNr,eigenePosX-5, eigenePosY+6);
                  else
                  g.drawString(""+uniformNr,eigenePosX-2, eigenePosY+6);
                 //legs
                  gg.setStroke(line1);
                  g.drawLine(eigenePosX-4, eigenePosY+6, eigenePosX-4, eigenePosY+9);
                  g.drawLine(eigenePosX+3, eigenePosY+6, eigenePosX+4, eigenePosY+9);
                 //arms
                  g.drawLine(eigenePosX-8, eigenePosY, eigenePosX-9, eigenePosY+1);
                  g.drawLine(eigenePosX+7, eigenePosY, eigenePosX+8, eigenePosY+1);
                 //shoes
                  g.setColor(Color.black);
                  g.drawLine(eigenePosX-4, eigenePosY+9, eigenePosX-5, eigenePosY+8);
                  g.drawLine(eigenePosX+4, eigenePosY+9, eigenePosX+5, eigenePosY+8);
                 //cap
                  /*gg.setStroke(line1);
                  g.drawLine(eigenePosX-13, eigenePosY+1, eigenePosX, eigenePosY-9);
                  g.fillArc(eigenePosX-9, eigenePosY-10,11, 11, 28, 180);*/

                 }

                 // repaint(50,ballX-5,ballY-5,10,10);
                 //repaint(35,eigenePosX-8,eigenePosY-8,16,16);
                  repaint(50);

                  receiveDaten();
              }

        }

      /** Klasse: SmallField (abgeleitet von der Canvas Klasse)     <br>
      *   Malt die Informationen ber den Spielstand und die Kondition des Spielers
      *   @author Kamil
      *   @version 1.0 / 4.7.02
      */
     public class SmallField extends Canvas
        {

         //Operationen
         /** Methode dient zur Aktualisierung der Daten
         *   @param     keine Parameter
         *   @return    kein Return-Wert
         */
         public void receiveDaten2() {
                PlayMode = SL.wm.getPlayMode();
              //  time = SL.wm.getTime();
                score = SL.wm.getScore();
                stamina = SL.wm.getStamina();
              //  side = SL.wm.getSide();

               // System.out.println("Side = ("+side+")");
         }

         /** Methode zeichnet das Info ber das Spiel und den Spieler
         *   @param     g    Graphics
         *   @return    kein Return-Wert
         *   @see java.awt.Graphics
         *   @see java.awt.Graphics2D
         */
         public void paint(Graphics g)
              {
                 BasicStroke lineSpace = new BasicStroke(1, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER,
                                                      10, new float[] {10, 10, }, 40);
                 Graphics2D gg = (Graphics2D)g;
                 g.setColor(Color.white);
                 g.setFont(new Font("SansSerif",Font.BOLD,18));

                 gg.setStroke(lineSpace);
                 g.drawLine(7, 52, 419,52);
                 //physical status of the player
                 g.drawString("player condition :",18,72);
                 g.drawString("stamina    ->   "+stamina,190,72);

            //    System.out.println("PlayMode = ("+PlayMode+")");
                //play modes
                if (PlayMode.equals("before_kick_off"))  g.drawString(""+PlayMode,141,19);
                if (PlayMode.equals("play_on"))          g.drawString(""+PlayMode,174,19);
                if (PlayMode.equals("time_over"))        g.drawString(""+PlayMode,162,19);
                if (PlayMode.equals("drop_ball"))        g.drawString(""+PlayMode,162,19);

                if (PlayMode.equals("kick_off_l"))    { if(side.equals("l"))    g.drawString("kick_off_our_team",128,19);
                                                        else                    g.drawString("kick_off_opponent",128,19);}
                if (PlayMode.equals("kick_off_r"))    { if(side.equals("r"))    g.drawString("kick_off_our_team",128,19);
                                                        else                    g.drawString("kick_off_opponent",128,19);}
                if (PlayMode.equals("kick_in_l"))     { if(side.equals("l"))    g.drawString("kick_in_our_team",130,19);
                                                        else                    g.drawString("kick_in_opponent",130,19);}
                if (PlayMode.equals("kick_in_r"))     { if(side.equals("r"))    g.drawString("kick_in_our_team",130,19);
                                                        else                    g.drawString("kick_in_opponent",130,19);}
                if (PlayMode.equals("free_kick_l"))   { if(side.equals("l"))    g.drawString("free_kick_our_team",124,19);
                                                        else                    g.drawString("free_kick_opponent",124,19);}
                if (PlayMode.equals("free_kick_r"))   { if(side.equals("r"))    g.drawString("free_kick_our_team",124,19);
                                                        else                    g.drawString("free_kick_opponent",124,19);}
                if (PlayMode.equals("corner_kick_l")) { if(side.equals("l"))    g.drawString("corner_kick_our_team",116,19);
                                                        else                    g.drawString("corner_kick_opponent",116,19);}
                if (PlayMode.equals("corner_kick_r")) { if(side.equals("r"))    g.drawString("corner_kick_our_team",116,19);
                                                        else                    g.drawString("corner_kick_opponent",116,19);}
                if (PlayMode.equals("goal_kick_l"))   { if(side.equals("l"))    g.drawString("goal_kick_our_team",124,19);
                                                        else                    g.drawString("goal_kick_opponent",124,19);}
                if (PlayMode.equals("goal_kick_r"))   { if(side.equals("r"))    g.drawString("goal_kick_our_team",124,19);
                                                        else                    g.drawString("goal_kick_opponent",124,19);}
                if (PlayMode.startsWith("goal_l_"))   { if(side.equals("l"))    g.drawString("goal_our_team",146,19);
                                                        else                    g.drawString("goal_opponent",146,19);}
                if (PlayMode.startsWith("goal_r_"))   { if(side.equals("r"))    g.drawString("goal_our_team",146,19);
                                                        else                    g.drawString("goal_opponent",146,19);}
                if (PlayMode.equals("offside_l"))     { if(side.equals("l"))    g.drawString("offside_our_team",130,19);
                                                        else                    g.drawString("offside_opponent",130,19);}
                if (PlayMode.equals("offside_r"))     { if(side.equals("r"))    g.drawString("offside_our_team",130,19);
                                                        else                    g.drawString("offside_opponent",130,19);}

                if (side.equals("l"))  {
                 g.drawString(""+teamname,20,19);                 //TeamName
                 g.drawString(""+opTeamName,355-(opTeamName.length()*9/2),19);              //opTeamName
                 g.setFont(new Font("SansSerif",Font.BOLD,21));
                 g.drawString(""+score[0], 55, 45);               //Score own
                 g.drawString(""+score[1], 355, 45);              //Score op
                 }
                else  {
                 g.drawString(""+opTeamName,55-(opTeamName.length()*9/2),19);                 //opTeamName
                 g.drawString(""+teamname,318,19);              //TeamName
                 g.setFont(new Font("SansSerif",Font.BOLD,21));
                 g.drawString(""+score[1], 55, 45);               //Score op
                 g.drawString(""+score[0], 355, 45);              //Score own
                     }

                 if (time < 10) g.drawString(""+time,203,45);                    //Time
                 if (time > 9 && time < 100) g.drawString(""+time,198,45);       //Time
                 if (time > 99 && time < 1000) g.drawString(""+time,192,45);     //Time
                 if (time > 999) g.drawString(""+time,186,45);                   //Time


                 repaint(100);
                 receiveDaten2();
              }

         }

   }
